// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//
// Copyright (c) Microsoft Corporation. All rights reserved

#include "hw5.h"

/******************************************************************
*                                                                 *
*  WinMain                                                        *
*                                                                 *
*  Application entrypoint                                         *
*                                                                 *
******************************************************************/

// Ÿ,ð,ӵ ϱ flag

float n_length;
float n_time = 0;


// ȭ麸/ / flag
WCHAR input_str;
bool isShow = false;
bool isStarted = true;


int WINAPI WinMain(
	HINSTANCE /* hInstance */,
	HINSTANCE /* hPrevInstance */,
	LPSTR /* lpCmdLine */,
	int /* nCmdShow */

	)
{
	// Ignoring the return value because we want to continue running even in the
	// unlikely event that HeapSetInformation fails.
	HeapSetInformation(NULL, HeapEnableTerminationOnCorruption, NULL, 0);
	HWND hWnd;





	if (SUCCEEDED(CoInitialize(NULL)))
	{
		{
			DemoApp app;

			if (SUCCEEDED(app.Initialize()))
			{
				app.RunMessageLoop();
			}
		}
		CoUninitialize();
	}

	return 0;
}

/******************************************************************
*                                                                 *
*  DemoApp::DemoApp constructor                                   *
*                                                                 *
*  Initialize member data                                         *
*                                                                 *
******************************************************************/

DemoApp::DemoApp() :
m_hwnd(NULL),
m_pD2DFactory(NULL),
m_pRT(NULL),
m_pPathGeometry(NULL),
m_pPathGeometry2(NULL),
m_pPathGeometry3(NULL),
m_pRedBrush(NULL),
m_pYellowBrush(NULL),
m_pGrayBrush(NULL),
m_Animation(),
m_pDWriteFactory(NULL),
m_pTextFormat(NULL),
m_pWICFactory(NULL),
m_pBackgroundBitmap(NULL),

m_pObject1Bitmap(NULL),
m_pStarBitmap(NULL),
m_pStarBitmap2(NULL),

m_pBackgroundBitmapBrush(NULL),
m_pBackgroundBitmapBrush2(NULL),
m_pBackgroundBitmapBrush3(NULL),
m_pObject1BitmapBrush(NULL),
m_pStarBitmapBrush(NULL),
m_pStarBitmapBrush2(NULL)
{
}

/******************************************************************
*                                                                 *
*  DemoApp::~DemoApp destructor                                   *
*                                                                 *
*  Release resources.                                             *
*                                                                 *
******************************************************************/

DemoApp::~DemoApp()
{
	SafeRelease(&m_pD2DFactory);
	SafeRelease(&m_pRT);
	SafeRelease(&m_pPathGeometry);
	SafeRelease(&m_pPathGeometry2);
	SafeRelease(&m_pPathGeometry3);
	SafeRelease(&m_pRedBrush);
	SafeRelease(&m_pYellowBrush);
	SafeRelease(&m_pGrayBrush);
	SafeRelease(&m_pDWriteFactory);
	SafeRelease(&m_pTextFormat);
	SafeRelease(&m_pWICFactory);

	SafeRelease(&m_pBackgroundBitmap);
	SafeRelease(&m_pObject1Bitmap);
	SafeRelease(&m_pStarBitmap);
	SafeRelease(&m_pStarBitmap2);

	SafeRelease(&m_pBackgroundBitmapBrush);
	SafeRelease(&m_pBackgroundBitmapBrush2);
	SafeRelease(&m_pBackgroundBitmapBrush3);
	SafeRelease(&m_pObject1BitmapBrush);
	SafeRelease(&m_pStarBitmapBrush);
	SafeRelease(&m_pStarBitmapBrush2);

}

/******************************************************************
*                                                                 *
*  DemoApp::Initialize                                            *
*                                                                 *
*  Create application window and device-independent resources     *
*                                                                 *
******************************************************************/

HRESULT DemoApp::Initialize()
{
	HRESULT hr;

	//register window class
	WNDCLASSEX wcex = { sizeof(WNDCLASSEX) };
	wcex.style = CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc = DemoApp::WndProc;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = sizeof(LONG_PTR);
	wcex.hInstance = HINST_THISCOMPONENT;
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = NULL;
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = L"201403132";

	RegisterClassEx(&wcex);

	hr = CreateDeviceIndependentResources();
	if (SUCCEEDED(hr))
	{
		// Create the application window.
		m_hwnd = CreateWindow(
			L"201403132",
			L"201403132",
			WS_OVERLAPPEDWINDOW,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			1000,
			700,
			NULL,
			NULL,
			HINST_THISCOMPONENT,
			this
			);
		hr = m_hwnd ? S_OK : E_FAIL;
		if (SUCCEEDED(hr))
		{
			float length = 0;
			hr = m_pPathGeometry->ComputeLength(
				NULL, //no transform
				&length
				);

			if (SUCCEEDED(hr))
			{
				m_Animation.SetStart(0);        //start at beginning of path
				m_Animation.SetEnd(length);     //length at end of path
				m_Animation.SetDuration(50.0f);  //seconds

				ZeroMemory(&m_DwmTimingInfo, sizeof(m_DwmTimingInfo));
				m_DwmTimingInfo.cbSize = sizeof(m_DwmTimingInfo);

				// Get the composition refresh rate. If the DWM isn't running,
				// get the refresh rate from GDI -- probably going to be 60Hz
				if (FAILED(DwmGetCompositionTimingInfo(NULL, &m_DwmTimingInfo)))
				{
					HDC hdc = GetDC(m_hwnd);
					m_DwmTimingInfo.rateCompose.uiDenominator = 1;
					m_DwmTimingInfo.rateCompose.uiNumerator = GetDeviceCaps(hdc, VREFRESH);
					ReleaseDC(m_hwnd, hdc);
				}

				ShowWindow(m_hwnd, SW_SHOWNORMAL);

				UpdateWindow(m_hwnd);
			}
		}


		if (SUCCEEDED(hr))
		{
			float length2 = 0;
			hr = m_pPathGeometry2->ComputeLength(
				NULL, //no transform
				&length2
				);

			if (SUCCEEDED(hr))
			{
				m_Animation2.SetStart(0);        //start at beginning of path
				m_Animation2.SetEnd(length2);     //length at end of path
				m_Animation2.SetDuration(10.0f);  //seconds

				ZeroMemory(&m_DwmTimingInfo2, sizeof(m_DwmTimingInfo2));
				m_DwmTimingInfo2.cbSize = sizeof(m_DwmTimingInfo2);

				// Get the composition refresh rate. If the DWM isn't running,
				// get the refresh rate from GDI -- probably going to be 60Hz
				if (FAILED(DwmGetCompositionTimingInfo(NULL, &m_DwmTimingInfo2)))
				{
					HDC hdc = GetDC(m_hwnd);
					m_DwmTimingInfo2.rateCompose.uiDenominator = 1;
					m_DwmTimingInfo2.rateCompose.uiNumerator = GetDeviceCaps(hdc, VREFRESH);
					ReleaseDC(m_hwnd, hdc);
				}

				ShowWindow(m_hwnd, SW_SHOWNORMAL);

				UpdateWindow(m_hwnd);
			}
		}


		if (SUCCEEDED(hr))
		{
			float length3 = 0;
			hr = m_pPathGeometry3->ComputeLength(
				NULL, //no transform
				&length3
				);

			if (SUCCEEDED(hr))
			{
				m_Animation3.SetStart(0);        //start at beginning of path
				m_Animation3.SetEnd(length3);     //length at end of path
				m_Animation3.SetDuration(10.0f);  //seconds

				ZeroMemory(&m_DwmTimingInfo3, sizeof(m_DwmTimingInfo3));
				m_DwmTimingInfo3.cbSize = sizeof(m_DwmTimingInfo3);

				// Get the composition refresh rate. If the DWM isn't running,
				// get the refresh rate from GDI -- probably going to be 60Hz
				if (FAILED(DwmGetCompositionTimingInfo(NULL, &m_DwmTimingInfo3)))
				{
					HDC hdc = GetDC(m_hwnd);
					m_DwmTimingInfo3.rateCompose.uiDenominator = 1;
					m_DwmTimingInfo3.rateCompose.uiNumerator = GetDeviceCaps(hdc, VREFRESH);
					ReleaseDC(m_hwnd, hdc);
				}

				ShowWindow(m_hwnd, SW_SHOWNORMAL);

				UpdateWindow(m_hwnd);
			}
		}
	}

	return hr;
}

/******************************************************************
*                                                                 *
*  DemoApp::CreateDeviceIndependentResources                      *
*                                                                 *
*  This method is used to create resources which are not bound    *
*  to any device. Their lifetime effectively extends for the      *
*  duration of the app.                                           *
*                                                                 *
******************************************************************/

HRESULT DemoApp::CreateDeviceIndependentResources()
{
	HRESULT hr;
	ID2D1GeometrySink *pSink = NULL;


	// Create a WIC factory.
	hr = CoCreateInstance(
		CLSID_WICImagingFactory,
		NULL,
		CLSCTX_INPROC_SERVER,
		IID_PPV_ARGS(&m_pWICFactory)
		);
	// Create a Direct2D factory.
	if (SUCCEEDED(hr))
		hr = D2D1CreateFactory(D2D1_FACTORY_TYPE_SINGLE_THREADED, &m_pD2DFactory);

	if (SUCCEEDED(hr))
	{
		// Create a shared DirectWrite factory
		hr = DWriteCreateFactory(
			DWRITE_FACTORY_TYPE_SHARED,
			__uuidof(IDWriteFactory),
			reinterpret_cast<IUnknown**>(&m_pDWriteFactory)
			);
	}

	if (SUCCEEDED(hr))
	{
		// Create a DirectWrite text format object.
		hr = m_pDWriteFactory->CreateTextFormat(
			L"Verdana",     // The font family name.
			NULL,           // The font collection (NULL sets it to use the system font collection).
			DWRITE_FONT_WEIGHT_REGULAR,
			DWRITE_FONT_STYLE_NORMAL,
			DWRITE_FONT_STRETCH_NORMAL,
			13.0f,
			L"en-us",
			&m_pTextFormat
			);
	}

	/* θ ׸  */
	if (SUCCEEDED(hr))
	{
		hr = m_pD2DFactory->CreatePathGeometry(&m_pPathGeometry);
	}
	if (SUCCEEDED(hr))
	{
		hr = m_pPathGeometry->Open(&pSink);
	}

	if (SUCCEEDED(hr))
	{
		hr = m_pD2DFactory->CreateStrokeStyle(
			D2D1::StrokeStyleProperties(
			D2D1_CAP_STYLE_FLAT,
			D2D1_CAP_STYLE_FLAT,
			D2D1_CAP_STYLE_ROUND,
			D2D1_LINE_JOIN_MITER,
			10.0f,
			D2D1_DASH_STYLE_DASH,
			0.0f),
			NULL,
			0,
			&m_pStrokeStyleDash
			);
	}
	if (SUCCEEDED(hr))
	{
		/*AddBezier Addline  θ ׷ */
		D2D1_POINT_2F currentLocation = { -200.0f, -100.0f };
		pSink->BeginFigure(currentLocation, D2D1_FIGURE_BEGIN_FILLED);

		pSink->AddBezier(D2D1::BezierSegment(D2D1::Point2F(-150, -250), D2D1::Point2F(-100, -220), D2D1::Point2F(-70, -170)));
		pSink->AddBezier(D2D1::BezierSegment(D2D1::Point2F(-80, -100), D2D1::Point2F(-150, -110), D2D1::Point2F(-160, -160)));
		pSink->AddBezier(D2D1::BezierSegment(D2D1::Point2F(-100, -270), D2D1::Point2F(-50, -260), D2D1::Point2F(0, -100)));
		pSink->AddBezier(D2D1::BezierSegment(D2D1::Point2F(10, 0), D2D1::Point2F(20, 0), D2D1::Point2F(50, -100)));
		pSink->AddBezier(D2D1::BezierSegment(D2D1::Point2F(70, -200), D2D1::Point2F(80, -200), D2D1::Point2F(100, -100)));
		pSink->AddBezier(D2D1::BezierSegment(D2D1::Point2F(110, 0), D2D1::Point2F(120, 0), D2D1::Point2F(150, -100)));
		pSink->AddBezier(D2D1::BezierSegment(D2D1::Point2F(170, -200), D2D1::Point2F(180, -200), D2D1::Point2F(200, 0)));
		pSink->AddBezier(D2D1::BezierSegment(D2D1::Point2F(100, 100), D2D1::Point2F(150, 150), D2D1::Point2F(200, 200)));
		pSink->AddBezier(D2D1::BezierSegment(D2D1::Point2F(350, 170), D2D1::Point2F(370, 120), D2D1::Point2F(250, 20)));
		pSink->AddLine(D2D1::Point2F(-150, 200));
		pSink->AddLine(D2D1::Point2F(-150, 150));
		pSink->AddLine(D2D1::Point2F(180, 150));
		pSink->AddBezier(D2D1::BezierSegment(D2D1::Point2F(90, -30), D2D1::Point2F(-80, 0), D2D1::Point2F(-150, 100)));
		pSink->AddLine(D2D1::Point2F(180, 50));
		pSink->AddLine(D2D1::Point2F(180, 30));
		pSink->AddLine(D2D1::Point2F(-150, 30));
		pSink->AddBezier(D2D1::BezierSegment(D2D1::Point2F(-100, -100), D2D1::Point2F(-350, -150), D2D1::Point2F(-300, -200)));

		pSink->EndFigure(D2D1_FIGURE_END_OPEN);

		hr = pSink->Close();
	}

	/* 1   */
	if (SUCCEEDED(hr))
	{
		hr = m_pD2DFactory->CreatePathGeometry(&m_pPathGeometry2);
	}
	if (SUCCEEDED(hr))
	{
		hr = m_pPathGeometry2->Open(&pSink);
	}

	if (SUCCEEDED(hr))
	{
		D2D1_POINT_2F currentLocation = { -350.0f, -500.0f };
		pSink->BeginFigure(currentLocation, D2D1_FIGURE_BEGIN_FILLED);

		pSink->AddLine(D2D1::Point2F(700, 500));

		pSink->EndFigure(D2D1_FIGURE_END_OPEN);

		hr = pSink->Close();
	}

	/* 2   */
	if (SUCCEEDED(hr))
	{
		hr = m_pD2DFactory->CreatePathGeometry(&m_pPathGeometry3);
	}
	if (SUCCEEDED(hr))
	{
		hr = m_pPathGeometry3->Open(&pSink);
	}

	if (SUCCEEDED(hr))
	{
		D2D1_POINT_2F currentLocation = { 450.0f, -50.0f };
		pSink->BeginFigure(currentLocation, D2D1_FIGURE_BEGIN_FILLED);

		pSink->AddLine(D2D1::Point2F(-100, 300));

		pSink->EndFigure(D2D1_FIGURE_END_OPEN);

		hr = pSink->Close();
	}


	SafeRelease(&pSink);

	return hr;
}

/******************************************************************
*                                                                 *
*  DemoApp::CreateDeviceResources                                 *
*                                                                 *
*  This method creates resources which are bound to a particular  *
*  D3D device. It's all centralized here, in case the resources   *
*  need to be recreated in case of D3D device loss (eg. display   *
*  change, remoting, removal of video card, etc).                 *
*                                                                 *
******************************************************************/

HRESULT DemoApp::CreateDeviceResources()
{
	HRESULT hr = S_OK;

	if (!m_pRT)
	{
		RECT rc;
		GetClientRect(m_hwnd, &rc);

		D2D1_SIZE_U size = D2D1::SizeU(
			rc.right - rc.left,
			rc.bottom - rc.top
			);

		// Create a Direct2D render target
		hr = m_pD2DFactory->CreateHwndRenderTarget(
			D2D1::RenderTargetProperties(),
			D2D1::HwndRenderTargetProperties(m_hwnd, size),
			&m_pRT
			);


		if (SUCCEEDED(hr))
		{
			// Create a red brush.
			hr = m_pRT->CreateSolidColorBrush(
				D2D1::ColorF(D2D1::ColorF::Red),
				&m_pRedBrush
				);
		}
		if (SUCCEEDED(hr))
		{
			// Create a yellow brush.
			hr = m_pRT->CreateSolidColorBrush(
				D2D1::ColorF(D2D1::ColorF::Yellow),
				&m_pYellowBrush
				);
		}
		if (SUCCEEDED(hr))
		{
			// Create a gray brush.
			hr = m_pRT->CreateSolidColorBrush(
				D2D1::ColorF(D2D1::ColorF::Gray),
				&m_pGrayBrush
				);
		}

		/*   ü Ʈʻ */
		if (SUCCEEDED(hr))
		{
			hr = LoadResourceBitmap(
				m_pRT,
				m_pWICFactory,
				L"background",
				L"Image",
				&m_pBackgroundBitmap
				);
		}

		if (SUCCEEDED(hr))
		{
			hr = LoadResourceBitmap(
				m_pRT,
				m_pWICFactory,
				L"object1",
				L"Image",
				&m_pObject1Bitmap
				);
		}

		if (SUCCEEDED(hr))
		{
			hr = LoadResourceBitmap(
				m_pRT,
				m_pWICFactory,
				L"star1",
				L"Image",
				&m_pStarBitmap
				);
		}

		if (SUCCEEDED(hr))
		{
			hr = LoadResourceBitmap(
				m_pRT,
				m_pWICFactory,
				L"star2",
				
				L"Image",
				&m_pStarBitmap2
				);
		}

		if (SUCCEEDED(hr))
		{
			hr = LoadResourceBitmap(
				m_pRT,
				m_pWICFactory,
				L"object1_mask",
				L"Image",
				&m_pObject1Bitmap_mask
				);
		}


		if (SUCCEEDED(hr))
		{
			D2D1_BITMAP_BRUSH_PROPERTIES propertiesXClampYClamp = D2D1::BitmapBrushProperties(
				D2D1_EXTEND_MODE_CLAMP,
				D2D1_EXTEND_MODE_CLAMP,
				D2D1_BITMAP_INTERPOLATION_MODE_NEAREST_NEIGHBOR
				);

			hr = m_pRT->CreateBitmapBrush(//
				m_pBackgroundBitmap,
				propertiesXClampYClamp,
				&m_pBackgroundBitmapBrush
				);


			if (SUCCEEDED(hr))//ΰ
			{
				hr = m_pRT->CreateBitmapBrush(
					m_pObject1Bitmap,
					propertiesXClampYClamp,
					&m_pObject1BitmapBrush
					);
			}

			if (SUCCEEDED(hr))//
			{
				hr = m_pRT->CreateBitmapBrush(
					m_pStarBitmap,
					propertiesXClampYClamp,
					&m_pStarBitmapBrush
					);
			}

			if (SUCCEEDED(hr))//Ķ
			{
				hr = m_pRT->CreateBitmapBrush(
					m_pStarBitmap2,
					propertiesXClampYClamp,
					&m_pStarBitmapBrush2
					);
			}
		}


	}

	return hr;
}

/******************************************************************
*                                                                 *
*  DemoApp::DiscardDeviceResources                                *
*                                                                 *
*  Discard device-specific resources which need to be recreated   *
*  when a D3D device is lost                                      *
*                                                                 *
******************************************************************/

void DemoApp::DiscardDeviceResources()
{
	SafeRelease(&m_pRT);
	SafeRelease(&m_pRedBrush);
	SafeRelease(&m_pYellowBrush);
	SafeRelease(&m_pGrayBrush);

	SafeRelease(&m_pBackgroundBitmap);
	SafeRelease(&m_pObject1Bitmap);
	SafeRelease(&m_pStarBitmap);
	SafeRelease(&m_pStarBitmap2);

	SafeRelease(&m_pBackgroundBitmapBrush);
	SafeRelease(&m_pBackgroundBitmapBrush2);
	SafeRelease(&m_pBackgroundBitmapBrush3);
	SafeRelease(&m_pObject1BitmapBrush);
	SafeRelease(&m_pStarBitmapBrush);
	SafeRelease(&m_pStarBitmapBrush2);
}

/******************************************************************
*                                                                 *
*  DemoApp::RunMessageLoop                                        *
*                                                                 *
*  Main window message loop                                       *
*                                                                 *
******************************************************************/

void DemoApp::RunMessageLoop()
{
	MSG msg;

	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
}

/******************************************************************
*                                                                 *
*  DemoApp::OnRender                                              *
*                                                                 *
*  Called whenever the application needs to display the client    *
*  window. This method draws a single frame of animated content   *
*                                                                 *
*  Note that this function will automatically discard device-     *
*  specific resources if the D3D device disappears during         *
*  function invocation, and will recreate the resources the next  *
*  time it's invoked.                                             *
*                                                                 *
******************************************************************/

HRESULT DemoApp::OnRender()
{
	HRESULT hr;

	hr = CreateDeviceResources();
	if (SUCCEEDED(hr))
	{
		D2D1_POINT_2F point, point2, point3;
		D2D1_POINT_2F tangent, tangent2, tangent3;

		D2D1_MATRIX_3X2_F triangleMatrix;
		D2D1_SIZE_F rtSize = m_pRT->GetSize();
		float minWidthHeightScale = min(rtSize.width, rtSize.height) / 512;

		D2D1::Matrix3x2F scale = D2D1::Matrix3x2F::Scale(
			minWidthHeightScale,
			minWidthHeightScale
			);

		D2D1::Matrix3x2F translation = D2D1::Matrix3x2F::Translation(
			rtSize.width / 2,
			rtSize.height / 2
			);

		D2D1::Matrix3x2F translation2 = D2D1::Matrix3x2F::Translation(
			rtSize.width / 16 + 500,
			rtSize.height / 16 + 150
			);

		D2D1::Matrix3x2F translation3 = D2D1::Matrix3x2F::Translation(
			rtSize.width / 16,
			rtSize.height / 16
			);


		// Prepare to draw.
		m_pRT->BeginDraw();

		// Reset to identity transform
		m_pRT->SetTransform(D2D1::Matrix3x2F::Identity());

		/* Ʈʹ׸ */
		D2D1_RECT_F rcBrushRect = D2D1::RectF(0, 0, rtSize.width, rtSize.height);

		//ֹ ׸ (MIRROR,WARP)
		m_pBackgroundBitmapBrush->SetExtendModeX(D2D1_EXTEND_MODE_MIRROR);
		m_pBackgroundBitmapBrush->SetExtendModeY(D2D1_EXTEND_MODE_WRAP);
		m_pRT->FillRectangle(&rcBrushRect, m_pBackgroundBitmapBrush);


		//center the path
		m_pRT->SetTransform(scale * translation);


		//draw the path in Gray and Dot
		//Ű(t)  
		if (isShow)
		{
			m_pRT->DrawGeometry(m_pPathGeometry, m_pRedBrush, 2, m_pStrokeStyleDash);
			m_pRT->DrawGeometry(m_pPathGeometry2, m_pRedBrush, 2, m_pStrokeStyleDash);
			m_pRT->DrawGeometry(m_pPathGeometry3, m_pRedBrush, 2, m_pStrokeStyleDash);
		}

		static float float_time = 0.0f;
		static float float_time2 = 0.0f;
		static float float_time3 = 0.0f;

		float length = m_Animation.GetValue(float_time);
		float length2 = m_Animation2.GetValue(float_time2);
		float length3 = m_Animation3.GetValue(float_time3);



		/////////////////////////////////////////////////////////////////////////////////////////
		/*Ž缱 ð  Ÿ*/
		hr = m_pPathGeometry->ComputePointAtLength(
			length,
			NULL,
			&point,
			&tangent);

		Assert(SUCCEEDED(hr));

		// Reorient the triangle so that it follows the
		// direction of the path.
		triangleMatrix = D2D1::Matrix3x2F(
			tangent.x, tangent.y,
			-tangent.y, tangent.x,
			point.x, point.y
			);

		/* θ 󰡴 Ž缱*/
		m_pRT->SetTransform(triangleMatrix * scale * translation);
		D2D1_SIZE_F size3 = m_pObject1Bitmap->GetSize();
		D2D1_RECT_F rcBrushRect4 = D2D1::RectF(0, 0, 180, 180);

		m_pRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED);
		m_pRT->FillOpacityMask(
			m_pObject1Bitmap_mask,
			m_pObject1BitmapBrush,
			D2D1_OPACITY_MASK_CONTENT_GRAPHICS,
			&rcBrushRect4,
			NULL
			);
		m_pRT->SetAntialiasMode(D2D1_ANTIALIAS_MODE_PER_PRIMITIVE);

		////////////////////////////////////////////////////////////////////////////////////////

		/*1 ð  Ÿ*/
		hr = m_pPathGeometry2->ComputePointAtLength(
			length2,
			NULL,
			&point2,
			&tangent2);

		Assert(SUCCEEDED(hr));

		// Reorient the triangle so that it follows the
		// direction of the path.
		triangleMatrix = D2D1::Matrix3x2F(
			tangent2.x, tangent2.y,
			-tangent2.y, tangent2.x,
			point2.x, point2.y
			);


		/* θ 󰡴 1*/
		m_pRT->SetTransform(triangleMatrix * scale * translation);
		D2D1_RECT_F rcBrushRect5 = D2D1::RectF(0, 0, 180, 180);
		m_pRT->FillRectangle(&rcBrushRect5, m_pStarBitmapBrush);


		////////////////////////////////////////////////////////////////////////////////////////

		/*2 ð  Ÿ*/
		hr = m_pPathGeometry3->ComputePointAtLength(
			length3,
			NULL,
			&point3,
			&tangent3);

		Assert(SUCCEEDED(hr));

		// Reorient the triangle so that it follows the
		// direction of the path.
		triangleMatrix = D2D1::Matrix3x2F(
			tangent3.x, tangent3.y,
			-tangent3.y, tangent3.x,
			point3.x, point3.y
			);

		/* θ 󰡴 2*/
		m_pRT->SetTransform(triangleMatrix * scale * translation);
		D2D1_RECT_F rcBrushRect6 = D2D1::RectF(0, 0, 180, 180);
		m_pRT->FillRectangle(&rcBrushRect6, m_pStarBitmapBrush2);


		// Commit the drawing operations.
		hr = m_pRT->EndDraw();

		if (hr == D2DERR_RECREATE_TARGET)
		{
			hr = S_OK;
			DiscardDeviceResources();
		}

		/* Ž缱 ִϸ̼   */
		if (float_time >= m_Animation.GetDuration())
		{
			/* ð Ÿ ϱ  */
			/*  ѹ ȯҶ ð ̸  */

			n_time += float_time;
			n_length += m_Animation.GetValue(float_time);
			float_time = 0.0f;
		}
		else
		{
			/* '̽ : /'   */
			if (isStarted)
				float_time += static_cast<float>(m_DwmTimingInfo.rateCompose.uiDenominator) /
				static_cast<float>(m_DwmTimingInfo.rateCompose.uiNumerator);

		}

		/* 1 ִϸ̼   */
		if (float_time2 >= m_Animation2.GetDuration())
		{
			float_time2 = 0.0f;
		}
		else
		{
			/* '̽ : /'   */
			if (isStarted)
				float_time2 += static_cast<float>(m_DwmTimingInfo2.rateCompose.uiDenominator) /
				static_cast<float>(m_DwmTimingInfo2.rateCompose.uiNumerator);
				

		}

		/* 2 ִϸ̼   */
		if (float_time3 >= m_Animation3.GetDuration())
		{
			float_time3 = 0.0f;
		}
		else
		{
			/* '̽ : /'   */
			if (isStarted)
				float_time3 += static_cast<float>(m_DwmTimingInfo3.rateCompose.uiDenominator) /
				static_cast<float>(m_DwmTimingInfo3.rateCompose.uiNumerator);

		}
	}

	return hr;
}

/******************************************************************
*                                                                 *
*  DemoApp::OnResize                                              *
*                                                                 *
*  If the application receives a WM_SIZE message, this method     *
*  resize the render target appropriately.                        *
*                                                                 *
******************************************************************/

void DemoApp::OnResize(UINT width, UINT height)
{
	if (m_pRT)
	{
		D2D1_SIZE_U size;
		size.width = width;
		size.height = height;

		// Note: This method can fail, but it's okay to ignore the
		// error here -- it will be repeated on the next call to
		// EndDraw.
		m_pRT->Resize(size);
	}
}

/******************************************************************
*                                                                 *
*  DemoApp::WndProc                                               *
*                                                                 *
*  Window message handler                                         *
*                                                                 *
******************************************************************/

LRESULT CALLBACK DemoApp::WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	LRESULT result = 0;
	HDC hdc;
	static int x;
	static int y;
	static BOOL bNowDraw = FALSE;






	if (message == WM_CREATE)
	{
		LPCREATESTRUCT pcs = (LPCREATESTRUCT)lParam;
		DemoApp *pDemoApp = (DemoApp *)pcs->lpCreateParams;

		::SetWindowLongPtrW(
			hwnd,
			GWLP_USERDATA,
			PtrToUlong(pDemoApp)
			);

		result = 1;
	}
	else
	{
		DemoApp *pDemoApp = reinterpret_cast<DemoApp *>(static_cast<LONG_PTR>(
			::GetWindowLongPtrW(
			hwnd,
			GWLP_USERDATA
			)));

		bool wasHandled = false;

		if (pDemoApp)
		{
			switch (message)
			{
			case WM_SIZE:
			{
				UINT width = LOWORD(lParam);
				UINT height = HIWORD(lParam);
				pDemoApp->OnResize(width, height);
			}
			result = 0;
			wasHandled = true;
			break;

			case WM_DISPLAYCHANGE:
			{
				InvalidateRect(hwnd, NULL, FALSE);
			}
			result = 0;
			wasHandled = true;
			break;

			case WM_PAINT:
			{
				pDemoApp->OnRender();

				// Do not call ValidateRect so that the window will be redrawn.
			}
			result = 0;
			wasHandled = true;
			break;


			case WM_LBUTTONDOWN:
				x = LOWORD(lParam);
				y = HIWORD(lParam);
				bNowDraw = TRUE;



			case WM_MOUSEMOVE:
				if (bNowDraw == TRUE)
				{
					hdc = GetDC(hwnd);
					MoveToEx(hdc, x, y, NULL);
					x = LOWORD(lParam);
					y = HIWORD(lParam);
					ReleaseDC(hwnd, hdc);
				}
			case WM_LBUTTONUP:		// 콺 ư ,
				bNowDraw = FALSE;	// 콺  ư ٰ Ѵ.
				return 0;
			case WM_LBUTTONDBLCLK:		//  Ŭ 
				InvalidateRect(hwnd, NULL, TRUE);	// ȭ ȿȭ (ȭ   ̴.)
				return 0;








			case WM_DESTROY:
			{
				PostQuitMessage(0);
			}
			result = 1;
			wasHandled = true;
			break;


			case WM_KEYDOWN:
			{
			}
			result = 0;
			wasHandled = true;
			break;
			}
		}

		if (!wasHandled)
		{
			result = DefWindowProc(hwnd, message, wParam, lParam);
		}
	}

	return result;
}


HRESULT DemoApp::LoadResourceBitmap(
	ID2D1RenderTarget *pRenderTarget,
	IWICImagingFactory *pIWICFactory,
	PCWSTR resourceName,
	PCWSTR resourceType,
	ID2D1Bitmap **ppBitmap
	)
{
	HRESULT hr = S_OK;
	IWICBitmapDecoder *pDecoder = NULL;
	IWICBitmapFrameDecode *pSource = NULL;
	IWICStream *pStream = NULL;
	IWICFormatConverter *pConverter = NULL;

	HRSRC imageResHandle = NULL;
	HGLOBAL imageResDataHandle = NULL;
	void *pImageFile = NULL;
	DWORD imageFileSize = 0;

	// Locate the resource.
	imageResHandle = FindResourceW(HINST_THISCOMPONENT, resourceName, resourceType);

	hr = imageResHandle ? S_OK : E_FAIL;
	if (SUCCEEDED(hr))
	{
		// Load the resource.
		imageResDataHandle = LoadResource(HINST_THISCOMPONENT, imageResHandle);

		hr = imageResDataHandle ? S_OK : E_FAIL;
	}

	if (SUCCEEDED(hr))
	{
		// Lock it to get a system memory pointer.
		pImageFile = LockResource(imageResDataHandle);

		hr = pImageFile ? S_OK : E_FAIL;
	}

	if (SUCCEEDED(hr))
	{
		// Calculate the size.
		imageFileSize = SizeofResource(HINST_THISCOMPONENT, imageResHandle);

		hr = imageFileSize ? S_OK : E_FAIL;
	}

	if (SUCCEEDED(hr))
	{
		// Create a WIC stream to map onto the memory.
		hr = pIWICFactory->CreateStream(&pStream);
	}

	if (SUCCEEDED(hr))
	{
		// Initialize the stream with the memory pointer and size.
		hr = pStream->InitializeFromMemory(
			reinterpret_cast<BYTE*>(pImageFile),
			imageFileSize
			);
	}

	if (SUCCEEDED(hr))
	{
		// Create a decoder for the stream.
		hr = pIWICFactory->CreateDecoderFromStream(
			pStream,
			NULL,
			WICDecodeMetadataCacheOnLoad,
			&pDecoder
			);
	}

	if (SUCCEEDED(hr))
	{
		// Create the initial frame.
		hr = pDecoder->GetFrame(0, &pSource);
	}

	if (SUCCEEDED(hr))
	{
		// Convert the image format to 32bppPBGRA
		// (DXGI_FORMAT_B8G8R8A8_UNORM + D2D1_ALPHA_MODE_PREMULTIPLIED).
		hr = pIWICFactory->CreateFormatConverter(&pConverter);
	}

	if (SUCCEEDED(hr))
	{
		hr = pConverter->Initialize(
			pSource,
			GUID_WICPixelFormat32bppPBGRA,
			WICBitmapDitherTypeNone,
			NULL,
			0.f,
			WICBitmapPaletteTypeMedianCut
			);
	}

	if (SUCCEEDED(hr))
	{
		// Create a Direct2D bitmap from the WIC bitmap.
		hr = pRenderTarget->CreateBitmapFromWicBitmap(
			pConverter,
			NULL,
			ppBitmap
			);
	}

	SafeRelease(&pDecoder);
	SafeRelease(&pSource);
	SafeRelease(&pStream);
	SafeRelease(&pConverter);

	return hr;
}